      *****************************************
      * Program name: eprb.cbl
      * This web-based problem tracking system
      * program demonstrates accepting data
      * from a user input form, then updating
      * a data file record.  This program uses
      * the REPLICA clause to simplify variable
      * definitions.
      *
      * Called by:  vprb.cbl, eprb.cbl
      * Calls: eprb.cbl
      *
      * Programs in this system:
      * prb.cbl, sprb.cbl, vprb.cbl, eprb.cbl
      *
      * This program calls itself from the html
      * form that it displays.  See the ACTION
      * attribute of the FORM tag in the 
      * web_body_html variable to see this.
      * 
      * Copyright 2000 Deskware, Inc.
      *****************************************
       1 prbfile PIC X(n) VALUE `PRB.TXT`.
       1 bytes_length PIC 9(4) VALUE 1116.

       FD prbfile RECORD IS bytes_length BYTES.  
      *
      * Record layout for prbfile; these variables
      * will be recalled as REPLICAs in html variables below;
      * see CobolScript manual for explanation of REPLICA.
       1 request_record.
        5 report_date     PIC X(8).
        5 email           PIC X(50).
        5 product         PIC X(50).
        5 problem         PIC X(500).
        5 resolution_date PIC X(8).
        5 resolution      PIC X(500).

       1 err_text1  PIC X(n) VALUE `You must enter a valid <B>email address</B>.<BR>`.


       1 web_header_html.
        5 `Content-type: text/html`.
        5 ` `.
        5 `<HTML><BODY>`.
        5 `<BR><BR>`.
        5 `<CENTER><FONT SIZE=4><B>Update a Problem Tracking Report</B></FONT></CENTER>`.
        5 `<HR><BR>`.
        5 `Please fill out this form to update a Problem Tracking Report.<BR>`.
        5 `After you complete the form, click on the <B>Submit Request</B> button.`.


       1 error_header_html.
        5 `Content-type: text/html`.
        5 ` `.
        5 `<HTML><BODY>`.
        5 `<BR><BR><BR><BR>`.
        5 `<CENTER><FONT SIZE=4><B>Update a Problem Tracking Report</B></FONT></CENTER>`.
        5 `<HR><BR>`.
        5 `You must enter a valid <B>email address</B>.<BR>`.
        5 `<BR>For more information on Problem Tracking Reports, `.
        5 `see the <A HREF="cobolscript.exe?prb.cbl">PTR Home Page</A> `.
 

       1 thank_you_header_html.
        5 `Content-type: text/html`.
        5 ` `.
        5 `<HTML><BODY>`.
        5 `<BR><BR><BR><BR>`.
        5 `<CENTER><FONT SIZE=4><B>Thank you for using our PTR System.</B></FONT></CENTER>`.
        5 `<HR><BR>`.
        5 `Your PTR regarding <B>`.

      * Replica definition of record product variable
        5 product REPLICA. 
        5 `</B> has been updated.  See below for the modified version.<BR><BR>`.
        5 `For more information on Problem Tracking Reports, `.
        5 `see the <A HREF="cobolscript.exe?prb.cbl">PTR Home Page</A><BR><BR>`.


       1 thank_you_body_html. 
        5 `<TABLE BORDER=1 BGCOLOR="dddddd" CELLSPACING=0 CELLPADDING=0>`.
        5 `<TR><TD><B>PTR Number:</B></TD>`.
        5 `<TD>`.

      * Replica definitions of record_key variable will follow.
        5 record_key PIC 9(8).

        5 `</TD></TR>`.
        5 `<TR><TD><B>Date Reported:</B></TD>`.
        5 `<TD>`.

      * Replica definition of file record report_date variable
        5 report_date REPLICA.

        5 `</TD></TR>`.
        5 `<TR><TD><B>Email Address:</B></TD>`.
        5 `<TD>`.

      * Replica definition of file record email variable
        5 email  REPLICA.

        5 `</TD></TR>`.
        5 `<TR><TD><B>Product:</B></TD>`.
        5 `<TD>`.

      * Replica definition of file record product variable
        5 product REPLICA.

        5 `</TD></TR>`.
        5 `<TR><TD><B>Description of Problem:</B></TD>`.
        5 `<TD>`.

      * Replica definition of file record problem variable
        5 problem  REPLICA.

        5 `</TD>`.
        5 `<TR><TD><B>Resoultion Date:</B></TD>`.
        5 `<TD>`.

      * Replica definition of file record resolution_date variable
        5 resolution_date REPLICA.

        5 `</TD></TR>`.
        5 `<TR><TD><B>Resoultion:</B></TD>`.
        5 `<TD>`.

      * Replica definition of file record resolution variable
        5 resolution REPLICA.

        5 `</TD></TR></TABLE>`.


       1 web_body_html.
        5 `<FORM ACTION="cobolscript.exe?eprb.cbl" METHOD="POST">`.
        5 `<INPUT TYPE="hidden" NAME="update_record" VALUE=1>`.
        5 `<TABLE BORDER=0 BGCOLOR="6699cc" CELLSPACING=0 CELLPADDING=0>`.
        5 `<TR><TD>PTR Number:</TD>`.
        5 `<TD><B>`.

      * Replica definition of record_key variable
        5 record_key  REPLICA.
        5 `</B>`.       
        5 `<INPUT TYPE="hidden" NAME="record_key" VALUE="`.

      * Replica definition of record_key variable
        5 record_key  REPLICA.
        5 `">`.
        5 `</TD></TR>`.
        5 `<TR><TD>Date Reported:</TD>`.
        5 `<TD><INPUT TYPE="TEXT" NAME="report_date" VALUE="`.

      * Replica definition of record report_date variable
        5 report_date REPLICA.
        5 `"></TD></TR>`.
        5 `<TR BGCOLOR="`.
        5 email_bgcolor PIC X(6)  VALUE `6699cc`.
        5 `">`.
        5 `<TD>Your Email Address:</FONT></TD><TD><INPUT TYPE="text" NAME="email" VALUE="`.

      * Replica definition of record email variable
        5 email  REPLICA.
        5 `"></TD></TR>`.
        5 `<TR><TD>Product:</TD>`.
        5 `<TD><SELECT NAME="product">`.
        5 `<OPTION SELECTED>`.

      * Replica definition of record product variable
        5 product REPLICA.
        5 `<OPTION>`.
        5 option2 PIC X(60).
        5 `<OPTION>`.
        5 option3 PIC X(60).
        5 `<OPTION>`.
        5 option4 PIC X(60).
        5 `<OPTION>`.
        5 option5 PIC X(60).
        5 `</SELECT></TD></TR>`.
        5 `<TR><TD>Description of Problem:</TD>`.
        5 `<TD><TEXTAREA NAME="problem" ROWS="5" COLS="60">`.

      * Replica definition of record problem variable
        5 problem REPLICA.
        5 `</TEXTAREA></TD></TR>`.
        5 `<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>`.
        5 `<TR><TD>Resolution Date:</TD>`.
        5 `<TD>`.

      * Replica definition of record resolution_date variable
        5 resolution_date REPLICA.
        5 `</TD></TR>`.
        5 `<TR><TD>Resolution:</TD>`.
        5 `<TD><TEXTAREA NAME="resolution" ROWS="5" COLS="60">`.

      * Replica definition of record resolution variable
        5 resolution REPLICA.
        5 `</TEXTAREA></TD></TR>`.
        5 `<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>`.
        5 `<TR><TD>&nbsp;</TD>`.
        5 `<TD><INPUT TYPE="Submit" VALUE="Submit Request">`.
        5 `<INPUT TYPE="Reset" VALUE="Reset Form"></TD>`.
        5 `</FORM>`.
        5 `</TR></TABLE>`.

       1 web_footer_html. 
         5 `<BR><HR><CENTER><FONT SIZE=-1>This program copyright &copy; 2000, Deskware, Inc.</CENTER></BODY></HTML>`.


      * update_record is a CGI form hidden field.  If we are entering this program from vprb.cbl,
      * update_record will be given a value of 1 during ACCEPT DATA FROM WEBPAGE.  If we are entering
      * this program from eprb.cbl, update record will have a value of 0.
       1 update_record PIC 9 VALUE 0.
       1 eof PIC 9 VALUE 0.
       1 error PIC 9 VALUE 0.
       1 content_length PIC 9(4) VALUE 0.


       MAIN.
           GETENV USING `CONTENT_LENGTH` content_length.

           IF content_length = 0 
              DISPLAYLF web_header_html
              DISPLAY `<CENTER><BR><B>This page may only be reached from within the PTR system.</B><BR><BR>`
              DISPLAY `<A HREF="cobolscript.exe?prb.cbl">Go to the PTR Home Page</A></CENTER>`
              DISPLAY web_footer_html
           ELSE
              ACCEPT DATA FROM WEBPAGE
              ACCEPT resolution_date FROM DATE
              PERFORM PROCESS-WEB-PAGE
           END-IF.
           GOBACK. 

       PROCESS-WEB-PAGE.
      * If the email address is blank, display an error message.
           IF email = SPACES
              DISPLAY `email = spaces`
              MOVE `990000`  TO email_bgcolor
              PERFORM CREATE-DROPDOWN-LIST
              MOVE err_text1 TO error_message
              DISPLAYLF error_header_html
              DISPLAY web_body_html
              DISPLAY web_footer_html
           ELSIF NOT(update_record)
              DISPLAYLF error_header_html
              PERFORM CREATE-DROPDOWN-LIST
              DISPLAY web_body_html
              DISPLAY web_footer_html        
           ELSE
              OPEN prbfile FOR UPDATING
      * Use POSITION statement to assist with record update
              POSITION prbfile AT RECORD record_key
              WRITE request_record TO prbfile
              CLOSE prbfile

              DISPLAYLF thank_you_header_html
              DISPLAY thank_you_body_html
              DISPLAY web_footer_html
           END-IF.


      * Here, we re-sort our dropdown list depending on what
      * product the client selected on the page before this error.
      ************************************************************
       CREATE-DROPDOWN-LIST.
      *    Windows case
           IF product(8:3) = `Win`
              MOVE `CS for SunOS`      TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
      *    SunOS case
           ELSIF product(8:3) = `Sun`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Deskware Web Site` TO option5
      *    Linux case
           ELSIF product(8:3) = `Lin`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for SunOS`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
      *    FreeBSD case 
           ELSIF product(8:4) = `Free`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for SunOS`      TO option4
              MOVE `Web Site`          TO option5
      *    Web site case
           ELSIF product(1:3) = `Web`
              MOVE `CS for Windows`    TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for SunOS`      TO option4
              MOVE `CS for FreeBSD`    TO option5
           ELSE
              MOVE `CS for Windows`    TO product
              MOVE `CS for SunOS`      TO option2
              MOVE `CS for Linux`      TO option3
              MOVE `CS for FreeBSD`    TO option4
              MOVE `Web Site`          TO option5
           END-IF.
